//AC130-Script by LurchiDerLurch ac130_AI_main
disableSerialization;

private["_display","_screen","_muni25","_muni40","_muni105","_difh","_difv","_x","_y","_structured","_infos","_pos","_setCirclePosition","_logic_center","_logic_plane"];

waitUntil {sleep 0.1; (LDL_ac130_active)};

_screen = [];
_muni25 = LDL_Ammo25;
_muni40 = LDL_Ammo40;
_muni105 = LDL_Ammo105;

_setCirclePosition =
{
	(_this select 0) setPosASL [(getPos LDL_cam_rotating_center select 0)+sin(LDL_cam_rotating_angle)*(_this select 1),(getPos LDL_cam_rotating_center select 1)+cos(LDL_cam_rotating_angle)*(_this select 1), LDL_cam_rotating_height];	
};

while {alive LDL_ac130_plane && alive player && !LDL_ac130_abort && LDL_ac130_active} do
{
	sleep 0.002;
	
	LDL_cam_rotating_angle = [LDL_cam_rotating_angle - LDL_cam_rotating_deg]call LDL_normalizeAngle;
	
	//Plane
	[LDL_ac130_plane,LDL_cam_rotating_radius]call _setCirclePosition;
	[LDL_gunPosition,(LDL_cam_rotating_radius-5)]call _setCirclePosition;
	LDL_ac130_plane setDir (LDL_cam_rotating_angle - 90);
	[LDL_ac130_plane,0,-15] call LDL_setPitchBank; //bank for the AC130
	
	//Countdown
	_secTotal = LDL_endTime-(time-LDL_startTime);
	_s = _secTotal MOD 60;
	_m  = (_secTotal/60) MOD 60;
	_h  = (_secTotal/60/60) MOD 24;
	
	hintSilent format ["AC-130: %1:%2:%3",floor(_h),floor(_m),floor(_s)];
	
	if(_secTotal <= 0) then
	{
		LDL_ac130_abort = true;
		hintSilent format ["AC-130: 0:0:0",floor(_h),floor(_m),floor(_s)];
	};
};

LDL_ac130_abort = true;
LDL_ac130_active = false;