//AC130-Script by LurchiDerLurch ac130_AI_shooting

private ["_logic","_angles","_heavyTargets","_lightTargets"];

waitUntil {sleep 0.1; (LDL_ac130_active)};

_logic = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];

_shoot = 
{
	[_this select 0, _this select 1,_this select 2, _this select 3]spawn
	{
		private ["_pos","_dirh","_dirv","_angles"];
		
		_pos = getPos LDL_gunPosition;
		_dirh = _this select 0;
		_dirv = _this select 1;
		_logic = _this select 3;	
		
		switch (_this select 2) do
		{
			case 0:
			{
				if (!LDL_shootingGun25) then
				{
					//25mm
					for [{_i = 0;},{_i < 15 + random 10},{_i = _i + 1;}] do 
					{
						[_dirh,_dirv,0,_pos]spawn LDL_calculateBullet;
						sleep 0.075;
						_angles = [LDL_gunPosition,_logic]call LDL_getObjectAngles;
						_dirh = [_angles select 0]call LDL_normalizeAngle;
						_dirv = [_angles select 1]call LDL_normalizeAngle;
						_pos = getPos LDL_gunPosition;
					};
				};
			};
			
			case 1:
			{
				if (!LDL_shootingGun40) then
				{						
					//40mm
					[_dirh,_dirv,1,_pos]spawn LDL_calculateBullet;
					sleep 0.5;
				};
				
			};
			
			case 2:
			{	
				if (!LDL_shootingGun105) then
				{					
					//105mm
					[_dirh,_dirv,2,_pos]spawn LDL_calculateBullet;
					sleep 3.5;	
				};
			};
		};
	};	
};

while {alive LDL_ac130_plane && alive player && !LDL_ac130_abort && LDL_ac130_active} do
{
	
	sleep 3;
	
	_heavyTargets = nearestObjects [getPos LDL_cam_rotating_center, ["LandVehicle","Air","Ship"], LDL_cam_rotating_radius-50];
	{
		
		if(side _x == side LDL_ac130_plane || side _x == civilian) then {_heavyTargets = _heavyTargets - [_x]};
		
	} forEach _heavyTargets;
	
	_lightTargets = nearestObjects [getPos LDL_cam_rotating_center, ["Man"], LDL_cam_rotating_radius-50];
	{
		
		if(side _x == side LDL_ac130_plane || side _x == civilian) then {_lightTargets = _lightTargets - [_x]};
		
	} forEach _lightTargets;
	
	if(count _heavyTargets > 0) then
	{
		_logic setPos getPos (_heavyTargets select (ceil(random count _heavyTargets)-1));
		_angles = [LDL_gunPosition,_logic]call LDL_getObjectAngles;
		LDL_guns_dirh = [_angles select 0]call LDL_normalizeAngle;
		LDL_guns_dirv = [_angles select 1]call LDL_normalizeAngle;
		_rand = random  2;
		_num = round(_rand); 
		[LDL_guns_dirh,LDL_guns_dirv,0,_logic]call _shoot;
	}
	else
	{
		if(count _lightTargets > 0) then
		{
			_logic setPos getPos (_lightTargets select (ceil(random count _lightTargets)-1));
			_angles = [LDL_gunPosition,_logic]call LDL_getObjectAngles;
			LDL_guns_dirh = [_angles select 0]call LDL_normalizeAngle;
			LDL_guns_dirv = [_angles select 1]call LDL_normalizeAngle; 
			[LDL_guns_dirh,LDL_guns_dirv,0,_logic]call _shoot;
		};
	};

};