//AC130-Script by LurchiDerLurch LDL_init
LDL_initDone = false;

LDL_ac130_client = compile preprocessFileLineNumbers "ac130\ac130_client.sqf";
LDL_ac130_init = compile preprocessFileLineNumbers "ac130\ac130_init.sqf";

//create some necessary objects
LDL_gunPosition = (createGroup (createCenter sideLogic)) createUnit ["LOGIC",[0,0,0],[],0,""];
LDL_cam_rotating_center = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0,0,0], [], 0, ""];

//preprocess functions
LDL_ac130_rot_camera = compile preprocessFileLineNumbers "ac130\Rotate\ac130_rot_camera.sqf";
LDL_ac130_rot_main = compile preprocessFileLineNumbers "ac130\Rotate\ac130_rot_main.sqf";
LDL_ac130_rot_waypoints = compile preprocessFileLineNumbers "ac130\Rotate\ac130_rot_waypoints.sqf";
LDL_ac130_rot_float = compile preprocessFileLineNumbers "ac130\Rotate\ac130_rot_float.sqf";
LDL_ac130_rot_setup = compile preprocessFileLineNumbers "ac130\Rotate\ac130_rot_setup.sqf";

LDL_ac130_att_camera = compile preprocessFileLineNumbers "ac130\Attach\ac130_att_camera.sqf";
LDL_ac130_att_main = compile preprocessFileLineNumbers "ac130\Attach\ac130_att_main.sqf";
LDL_ac130_att_setup = compile preprocessFileLineNumbers "ac130\Attach\ac130_att_setup.sqf";

LDL_ac130_AI_main = compile preprocessFileLineNumbers "ac130\AI\ac130_AI_main.sqf";
LDL_ac130_AI_shooting = compile preprocessFileLineNumbers "ac130\AI\ac130_AI_shooting.sqf";
LDL_ac130_AI_setup = compile preprocessFileLineNumbers "ac130\AI\ac130_AI_setup.sqf";

LDL_uav_rot_camera = compile preprocessFileLineNumbers "ac130\UAV\uav_rot_camera.sqf";
LDL_uav_rot_main = compile preprocessFileLineNumbers "ac130\UAV\uav_rot_main.sqf";
LDL_uav_rot_setup = compile preprocessFileLineNumbers "ac130\UAV\uav_rot_setup.sqf";

LDL_mando_angles = compile (preprocessFileLineNumbers "ac130\mando_angles.sqf");
LDL_setPitchBank = compile (preprocessFileLineNumbers "ac130\setPitchBank.sqf");
LDL_ac130_guns = compile preprocessFileLineNumbers "ac130\ac130_guns.sqf";
LDL_ac130_blink = compile preprocessFileLineNumbers "ac130\ac130_blink.sqf";
LDL_ac130_troops = compile preprocessFileLineNumbers "ac130\ac130_troops.sqf";
LDL_ac130_sound = compile preprocessFileLineNumbers "ac130\ac130_sound.sqf";

[]spawn LDL_ac130_client;
[]call LDL_ac130_init;

LDL_showParticles = true;
LDL_ac130_active = false;

// public Variable for every C130J
if(isServer) then
{
	{
		if (_x isKindOf "C130J") then
		{
			_x setVariable ["LDL_planeInUse", false, true];
		};
	} forEach vehicles;
};

// initialisation of PVEH
"LDL_PublicLDLCannon25Sound" addPublicVariableEventHandler
{
	_soundSource = _this select 1;
	_soundSource say format ["LDL_gun01"];
};
"LDL_PublicLDLCannon40Sound" addPublicVariableEventHandler
{
	_soundSource = _this select 1;
	_soundSource say format ["LDL_gun02"];
};
"LDL_PublicLDLCannon105Sound" addPublicVariableEventHandler
{
	_soundSource = _this select 1;
	_soundSource say format ["LDL_gun03"];
};

"LDL_PublicLDLCannon25FX" addPublicVariableEventHandler
{
	_shell = (_this select 1) select 0;
	_vel = (_this select 1) select 1;
	_weapon = (_this select 1) select 2;
	#include "ac130_createParticleSource.sqf"
};
"LDL_PublicLDLCannon40FX" addPublicVariableEventHandler
{
	_shell = (_this select 1) select 0;
	_vel = (_this select 1) select 1;
	_weapon = (_this select 1) select 2;
	#include "ac130_createParticleSource.sqf"
};
"LDL_PublicLDLCannon105FX" addPublicVariableEventHandler
{
	_shell = (_this select 1) select 0;
	_vel = (_this select 1) select 1;
	_weapon = (_this select 1) select 2;
	#include "ac130_createParticleSource.sqf"
};

LDL_initDone = true;