//AC130-Script by LurchiDerLurch ac130_rot_main
disableSerialization;

private["_display","_screen","_muni25","_muni40","_muni105","_difh","_difv","_x","_y","_structured","_infos","_pos","_setCirclePosition","_logic_center","_logic_plane"];

waitUntil {sleep 0.1; (LDL_ac130_active)};

_display = (finddisplay 1000);
_screen = [];
_muni25 = LDL_Ammo25;
_muni40 = LDL_Ammo40;
_muni105 = LDL_Ammo105;

_logic_center = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];
_logic_plane = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];

_function_hud = compile preprocessFileLineNumbers "ac130\ac130_HUD.sqf";

_setCirclePosition =
{
	(_this select 0) setPosASL [(getPos (_this select 1) select 0)+sin(LDL_cam_rotating_angle)*LDL_cam_rotating_radius,(getPos (_this select 1) select 1)+cos(LDL_cam_rotating_angle)*LDL_cam_rotating_radius, LDL_cam_rotating_height];	
};

while {dialog && alive LDL_ac130_plane && alive player && !LDL_ac130_abort} do
{
	sleep 0.002;
	
	//Plane
	if (LDL_mouseButtons select 1) then 
	{
		_logic_center setPos screenToWorld [0.5,0.5];
		
		[_logic_plane,_logic_center] call _setCirclePosition;
		_ang = [LDL_ac130_plane, _logic_plane] call LDL_mando_angles;
		_dif = _ang select 1;
		
		//ac130_pilot sideChat format["AC130-Pilot: Target %1, distance: %2 m.",getPos _logic_center,round(([getPos ac130_plane select 0,getPos ac130_plane select 1,getPos _logic_center select 2]) distance _logic_center)];
		
		if (!(_dif < 1 && _dif > -1)) then
		{
			LDL_flyMode = 2; //waiting to float
		};
	};
	
	if(LDL_flyMode == 2) then
	{
		//waiting to float
		[_logic_plane,_logic_center] call _setCirclePosition;
		
		_ang = [LDL_ac130_plane, _logic_plane] call LDL_mando_angles;
		_dif = _ang select 1;
		
		_pos = (worldToScreen getPos _logic_center);
		if (count _pos != 2) then
     		{                              
      		_pos = [-1,-1];
     		};
		(_display displayCtrl 1006) ctrlSetPosition [(_pos select 0)-SafeZoneW/64,(_pos select 1)-SafeZoneH/64];
		(_display displayCtrl 1006) ctrlSetTextColor [1,1,1,0.5];
		(_display displayCtrl 1006) ctrlCommit 0;
		
		if (_dif < 1 && _dif > -1) exitWith
		{
			LDL_flyMode = 3; //float
			
			LDL_cam_rotating_center setPosASL [getPos LDL_cam_rotating_center select 0,getPos LDL_cam_rotating_center select 1,getPosASL _logic_center select 2];
			
			[LDL_cam_rotating_center,_logic_center,1,1,false,false]spawn LDL_ac130_rot_float;
			
			(_display displayCtrl 1006) ctrlSetTextColor [1,1,1,0];
		};
	};
		
	_difh = [(LDL_cam_dirh - LDL_cam_rotating_angle)]call LDL_normalizeAngle;
	_difv = [LDL_cam_dirv - 180]call LDL_normalizeAngle;
	
	[]call _function_hud;
	
	//Shooting
	if (LDL_mouseButtons select 0 && !(LDL_mouseButtons select 4)) then 
	{
		if((LDL_guns_enabled && LDL_viewMode == 1) || LDL_viewMode == 0) then
		{
			if(LDL_viewMode == 0) then
			{
				[getPos LDL_ac130_cam,LDL_cam_dirh,LDL_cam_dirv]spawn LDL_ac130_guns;
			}
			else
			{
				[getPos LDL_gunPosition,LDL_guns_dirh,LDL_guns_dirv]spawn LDL_ac130_guns;
			};
		};
	};
};

//abort all scripts
camDestroy LDL_ac130_cam;
setAperture -1;
LDL_ac130_cam cameraeffect ["terminate", "back"];

ppEffectDestroy LDL_ppccor;
ppEffectDestroy LDL_ppcinv;
ppEffectDestroy LDL_ppfilm;
ppEffectDestroy LDL_ppdyblur;
setAperture -1; 

//Remove DEH again on exit
(findDisplay 46) displayRemoveEventHandler ["keyDown",LDL_KeyDownDEH];
(findDisplay 46) displayRemoveEventHandler ["keyUp",LDL_KeyUpDEH];

while{dialog} do
{
	closeDialog 0;	
};

if(!alive LDL_ac130_plane) then
{
	_cam = "camera" camcreate (LDL_ac130_plane modelToWorld [20,0,50]);
	_cam cameraeffect ["internal", "back"];
	showCinemaBorder false;
	camUseNVG false;

	_cam camSetTarget LDL_ac130_plane;
	_cam camCommit 3;
	
	sleep 3;
	
	titleText ["", "BLACK OUT",0.5];
	
	sleep 0.5;
	
	camDestroy _cam;
	_cam cameraeffect ["terminate", "back"];
	
	titleText ["", "BLACK IN",1];
};

LDL_ac130_plane setVariable ["LDL_Ammo25", LDL_Ammo25, true];
LDL_ac130_plane setVariable ["LDL_Ammo40", LDL_Ammo40, true];
LDL_ac130_plane setVariable ["LDL_Ammo105", LDL_Ammo105, true];

LDL_ac130_abort = true;

waitUntil{(LDL_scriptTerminated == 4)};

LDL_ac130_active = false;