//AC130-Script by LurchiDerLurch ac130_rot_main
disableSerialization;

private["_display","_screen","_difh","_difv","_x","_y","_structured","_infos","_pos","_setCirclePosition","_logic_center","_logic_plane","_aiming"];

waitUntil {sleep 0.1;(LDL_ac130_active)};

_display = (finddisplay 1000);
_screen = [];
LDL_aiming = false;

_logic_center = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];
_logic_plane = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];
LDL_logic_object = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];

_function_hud = compile preprocessFileLineNumbers "ac130\ac130_HUD.sqf";

_setCirclePosition =
{
	(_this select 0) setPosASL [(getPos (_this select 1) select 0)+sin(LDL_cam_rotating_angle)*LDL_cam_rotating_radius,(getPos (_this select 1) select 1)+cos(LDL_cam_rotating_angle)*LDL_cam_rotating_radius, LDL_cam_rotating_height];	
};

while {dialog && alive LDL_ac130_plane && alive player} do
{
	sleep 0.002;
	
	//Plane
	if (LDL_mouseButtons select 1) then 
	{
		_logic_center setPos screenToWorld [0.5,0.5];
		
		[_logic_plane,_logic_center] call _setCirclePosition;
		_ang = [LDL_ac130_plane, _logic_plane] call LDL_mando_angles;
		_dif = _ang select 1;
		
		//ac130_pilot sideChat format["AC130-Pilot: Target %1, distance: %2 m.",getPos _logic_center,round(([getPos ac130_plane select 0,getPos ac130_plane select 1,getPos _logic_center select 2]) distance _logic_center)];
		
		if (!(_dif < 1 && _dif > -1)) then
		{
			LDL_flyMode = 2; //waiting to float
		};
	};
	
	if(LDL_flyMode == 2) then
	{
		//waiting to float
		[_logic_plane,_logic_center] call _setCirclePosition;
		
		_ang = [LDL_ac130_plane, _logic_plane] call LDL_mando_angles;
		_dif = _ang select 1;
		
		_pos = (worldToScreen getPos _logic_center);
		if (count _pos != 2) then
     		{                              
      		_pos = [-1,-1];
     		};
		(_display displayCtrl 1006) ctrlSetPosition [(_pos select 0)-SafeZoneW/64,(_pos select 1)-SafeZoneH/64];
		(_display displayCtrl 1006) ctrlSetTextColor [1,1,1,0.5];
		(_display displayCtrl 1006) ctrlCommit 0;
		
		if (_dif < 1 && _dif > -1) exitWith
		{
			LDL_flyMode = 3; //float
			
			LDL_cam_rotating_center setPosASL [getPos LDL_cam_rotating_center select 0,getPos LDL_cam_rotating_center select 1,getPosASL _logic_center select 2];
			
			[LDL_cam_rotating_center,_logic_center,1,1,false,false]spawn LDL_ac130_rot_float;
			
			(_display displayCtrl 1006) ctrlSetTextColor [1,1,1,0];
		};
	};
		
	_difh = [(LDL_cam_dirh - LDL_cam_rotating_angle)]call LDL_normalizeAngle;
	_difv = [LDL_cam_dirv - 180]call LDL_normalizeAngle;
	
	[]call _function_hud;
		
	//Shooting
	if (LDL_mouseButtons select 0 && !(LDL_mouseButtons select 4) && !LDL_aiming) then 
	{
		LDL_aiming = true;
		//LDL_logic_object setPos [getPos LDL_ac130_plane select 0,getPos LDL_ac130_plane select 1,0];
		LDL_logic_object setPos screenToWorld[0.5,0.5];
		
		[]spawn
		{
			//disableSerialization;
			//_display = (finddisplay 1000);
			
			while{LDL_mouseButtons select 0} do
			{
				/*
				sleep 0.01;
				_posWtoM = LDL_logic_object worldToModel (screenToWorld [0.5,0.5]);
				_xMissing = _posWtoM select 0;
				_yMissing = _posWtoM select 1;
				_zMissing = _posWtoM select 2;
				
				_distance3D = ((screenToWorld [0.5,0.5]) distance LDL_logic_object);
				
				_xWalk = _xMissing/(_distance3D*0.1);
				_yWalk = _yMissing/(_distance3D*0.1);
				_zWalk = _zMissing/(_distance3D*0.1);
				
				//_heightNow = _heightNow + _zWalk;
				
				LDL_logic_object setPos [(LDL_logic_object modelToWorld [_xWalk,_yWalk,0]) select 0,(LDL_logic_object modelToWorld [_xWalk,_yWalk,0]) select 1,0];
				
				_screen = worldToScreen (getPos LDL_logic_object);
				
			      if (count _screen != 2) then
			     	{                              
			      	_screen = [-1,-1];
			     	};
     
				(_display displayCtrl 1022) ctrlSetTextColor [1,1,1,1];
				(_display displayCtrl 1022) ctrlSetPosition [(_screen select 0)-0.02,(_screen select 1)-0.025];
				(_display displayCtrl 1022) ctrlCommit 0; 
				*/
				
				sleep 0.05;
				[screenToWorld [0.5,0.5]]spawn
				{
					_pos = _this select 0;
					disableSerialization;
					_display = (finddisplay 1000);
			
					while{(_pos distance LDL_logic_object) > 5} do
					{
						sleep 0.01;
						_posWtoM = LDL_logic_object worldToModel (_pos);
						_xMissing = _posWtoM select 0;
						_yMissing = _posWtoM select 1;
						_zMissing = _posWtoM select 2;
						
						_distance3D = (_pos distance LDL_logic_object);
						
						_xWalk = _xMissing/(_distance3D*0.1);
						_yWalk = _yMissing/(_distance3D*0.1);
						_zWalk = _zMissing/(_distance3D*0.1);

						LDL_logic_object setPos [(LDL_logic_object modelToWorld [_xWalk,_yWalk,0]) select 0,(LDL_logic_object modelToWorld [_xWalk,_yWalk,0]) select 1,0];
				     		
				     		_screen = worldToScreen (getPos LDL_logic_object);
						
					      if (count _screen != 2) then
					     	{                              
					      	_screen = [-1,-1];
					     	};
					     
					     (_display displayCtrl 1023) ctrlSetPosition [(_screen select 0)-SafeZoneW/64,(_screen select 1)-SafeZoneH/64];
					     (_display displayCtrl 1023) ctrlCommit 0; 
				      };
				};
				
			};
			
			LDL_aiming = false;
		};
	};
};

//abort all scripts
camDestroy LDL_ac130_cam;
setAperture -1;
LDL_ac130_cam cameraeffect ["terminate", "back"];

ppEffectDestroy LDL_ppccor;
ppEffectDestroy LDL_ppcinv;
ppEffectDestroy LDL_ppfilm;
ppEffectDestroy LDL_ppdyblur;
setAperture -1; 

//Remove DEH again on exit
(findDisplay 46) displayRemoveEventHandler ["keyDown",LDL_KeyDownDEH];
(findDisplay 46) displayRemoveEventHandler ["keyUp",LDL_KeyUpDEH];

while{dialog} do
{
	closeDialog 0;	
};

if(!alive LDL_ac130_plane) then
{
	_cam = "camera" camcreate (LDL_ac130_plane modelToWorld [20,0,50]);
	_cam cameraeffect ["internal", "back"];
	showCinemaBorder false;
	camUseNVG false;

	_cam camSetTarget LDL_ac130_plane;
	_cam camCommit 3;
	
	sleep 3;
	
	titleText ["", "BLACK OUT",0.5];
	
	sleep 0.5;
	
	camDestroy _cam;
	_cam cameraeffect ["terminate", "back"];
	
	titleText ["", "BLACK IN",1];
};

LDL_ac130_abort = true;

waitUntil{(LDL_scriptTerminated == 4)};

LDL_ac130_active = false;