//AC130-Script by LurchiDerLurch ac130_att_main
disableSerialization;

private["_display","_screen","_muni25","_muni40","_muni105","_difh","_difv","_x","_y","_structured","_infos","_pos","_setCirclePosition","_logic_center","_logic_plane"];

waitUntil {sleep 0.1; (LDL_ac130_active)};

_display = (finddisplay 1000);
_screen = [];
_muni25 = LDL_Ammo25;
_muni40 = LDL_Ammo40;
_muni105 = LDL_Ammo105;

_logic_center = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];
_logic_plane = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];

_function_hud = compile preprocessFileLineNumbers "ac130\ac130_HUD.sqf";

_setCirclePosition =
{
	(_this select 0) setPosASL [(getPos (_this select 1) select 0)+sin(LDL_cam_rotating_angle)*LDL_cam_rotating_radius,(getPos (_this select 1) select 1)+cos(LDL_cam_rotating_angle)*LDL_cam_rotating_radius, LDL_cam_rotating_height];	
};

while {dialog && alive LDL_ac130_plane && alive player && !LDL_ac130_abort} do
{
	sleep 0.002;
	
	//Plane
	/*
	if (LDL_mouseButtons select 1) then 
	{
		LDL_cam_rotating_center setPos screenToWorld [0.5,0.5];
		
		LDL_waypoint setWaypointPosition [getPos LDL_cam_rotating_center, 10];
		
	};
	*/
	
	//LDL_ac130_plane flyInHeight LDL_cam_rotating_height;
	//LDL_ac130_plane setSpeedMode "LIMITED";
	
	_difh = [(LDL_cam_dirh - (getDir LDL_ac130_plane) -90)]call LDL_normalizeAngle;
	_difv = [LDL_cam_dirv - 180]call LDL_normalizeAngle;
	
	[]call _function_hud;

	//Shooting
	if (LDL_mouseButtons select 0 && !(LDL_mouseButtons select 4)) then 
	{
		if((LDL_guns_enabled && LDL_viewMode == 1) || LDL_viewMode == 0) then
		{
			if(LDL_viewMode == 0) then
			{
				[LDL_ac130_cam modelToWorld[0,3,0],LDL_cam_dirh,LDL_cam_dirv]spawn LDL_ac130_guns;
			}
			else
			{
				[getPos LDL_gunPosition,LDL_guns_dirh,LDL_guns_dirv]spawn LDL_ac130_guns;
			};
		};
	};
};

//abort all scripts
camDestroy LDL_ac130_cam;
setAperture -1; //TODO: reset to current GDT value
LDL_ac130_cam cameraeffect ["terminate", "back"];
LDL_ac130_plane enableSimulation true;

ppEffectDestroy LDL_ppccor;
ppEffectDestroy LDL_ppcinv;
ppEffectDestroy LDL_ppfilm;
ppEffectDestroy LDL_ppdyblur;
setAperture -1; //TODO: reset to current GDT value

deleteWaypoint LDL_waypoint;

while{dialog} do
{
	closeDialog 0;	
};

//Remove DEH again on exit
(findDisplay 46) displayRemoveEventHandler ["keyDown",LDL_KeyDownDEH];
(findDisplay 46) displayRemoveEventHandler ["keyUp",LDL_KeyUpDEH];

//Update ammo count of the AC130 for all clients
LDL_ac130_plane setVariable ["LDL_Ammo25", LDL_Ammo25, true];
LDL_ac130_plane setVariable ["LDL_Ammo40", LDL_Ammo40, true];
LDL_ac130_plane setVariable ["LDL_Ammo105", LDL_Ammo105, true];

LDL_ac130_abort = true;

waitUntil{(LDL_scriptTerminated == 3)};

LDL_ac130_active = false;