//AC130-Script by LurchiDerLurch ac130_rot_waypoints

private ["_pos","_color","_size","_glowSize","_vel","_weight","_volume","_rubbing"];

_logic = (createGroup (createCenter sideLogic)) createUnit ["LOGIC", [0, 0, 0], [], 0, ""];

waitUntil {sleep 0.1; (LDL_ac130_active)};

_size = [1*2];
_glowSize = [(1*3)/5];
_vel = [0,0,0];
_weight = 1.275;
_volume = 1;
_rubbing = 0;

while {!LDL_ac130_abort && LDL_showWaypoints && LDL_ac130_active} do
{
	if(LDL_flyMode != 3) then
	{
	
		if(LDL_flyMode == 2) then
		{
			_color = [[1,0.5,0,1],[1,0.5,0,1],[1,0.5,0,1]]; //orange
		}
		else
		{
			_color = [[0,1,0,1],[0,1,0,1],[0,1,0,1]]; //green
		};
		
		for [{_i=0},{_i < 360},{_i = _i + 5}] do 
		{
			sleep 0.01;
			_logic setPosASL [(getPos LDL_cam_rotating_center select 0)+sin(_i)*LDL_cam_rotating_radius,(getPos LDL_cam_rotating_center select 1)+cos(_i)*LDL_cam_rotating_radius, LDL_cam_rotating_height];
			drop["\Ca\Data\kouleSvetlo", "", "Billboard", 1, 7, getPos _logic, _vel, 0, _weight, _volume, _rubbing, _size, _color, [0, 1], 0, 0, "", "", ""];
		};
	
		_now = time;
		waitUntil{((time > _now + 5) || LDL_ac130_abort)};
	}
	else
	{
		sleep 1;
	};
};

waitUntil {sleep 0.1;(LDL_showWaypoints || LDL_ac130_abort || !LDL_ac130_active)};

if (!LDL_ac130_abort && LDL_ac130_active) then
{
	[]spawn LDL_ac130_rot_waypoints;
};

LDL_scriptTerminated = LDL_scriptTerminated + 1;


