//AC130-Script by LurchiDerLurch ac130_init
disableSerialization;

//functions
LDL_KeyEvents = 
{
	private["_type","_params","_handled", "_ctrl", "_dikCode", "_shift", "_ctrlKey", "_alt","_display"];
	
	_params = _this select 0;
	_type = _this select 1;
  	_ctrl = _params select 0;
 	_dikCode = _params select 1;
 	_shift = _params select 2;
 	_ctrlKey = _params select 3;
 	_alt = _params select 4;
 	_display = (finddisplay  1000);
 
 	switch (_type) do
	{
		case "down":
		{
			if (_dikCode == 1) then
			{
				//ESC pressed
				
			};
			
			if (_dikCode == 17) then
			{
				//W pressed
				/*
				if (LDL_cam_rotating_radius > 500) then
				{
					LDL_cam_rotating_radius = LDL_cam_rotating_radius - 1;
				};
				*/
				
				
			};
			
			if (_dikCode == 30) then
			{
				//A pressed
				/*
				if (LDL_cam_rotating_deg >= 0.05) then
				{
					LDL_cam_rotating_deg = LDL_cam_rotating_deg - 0.001;
				};
				*/
			};
			
			if (_dikCode == 31) then
			{
				//S pressed
				/*
				LDL_cam_rotating_radius = LDL_cam_rotating_radius + 1;
				*/
			};
			
			if (_dikCode == 32) then
			{
				//D pressed
				/*
				if (LDL_cam_rotating_deg < 0.3) then
				{
					LDL_cam_rotating_deg = LDL_cam_rotating_deg + 0.001;
				};
				*/
			};
			
			if (_dikCode == 41) then
			{
				//^ pressed
				[-1]call LDL_switchWeapon
			};
			
			if (_dikCode == 35 || _dikCode == 59) then
			{
				//F1 || H pressed
				[]spawn LDL_showHelp;
			};
			
			if (_dikCode == 60) then
			{
				//F2 pressed
				if(LDL_showFlir) then
				{
					//FLIR off
					LDL_showFlir = false;
					(_display displayctrl 1002) ctrlSetText "Flir off";
					(_display displayctrl 1017) ctrlSetTextColor [0,0,0,1];
				}
				else
				{
					//FLIR on	
					LDL_showFlir = true;
					(_display displayctrl 1002) ctrlSetText "Flir on";
					(_display displayctrl 1017) ctrlSetTextColor [1,0,0,1];
					
					//NVG off
					LDL_useNVG = false;
					(_display displayctrl 1018) ctrlSetTextColor [0,0,0,1];
					[]call LDL_enableNVG;
				};
				
				[LDL_inversion]call LDL_createEffect;
			};
			
			if (_dikCode == 61) then
			{
				//F3 pressed
				[]call LDL_changeView;
			};
			
			if (_dikCode == 62) then
			{
				//F4 pressed
				if(LDL_useNVG) then
				{
					//NVG off
					LDL_useNVG = false;
					(_display displayctrl 1002) ctrlSetText "NVG off";
					(_display displayctrl 1018) ctrlSetTextColor [0,0,0,1];
				}
				else
				{
					//NVG on	
					LDL_useNVG = true;
					(_display displayctrl 1002) ctrlSetText "NVG on";
					(_display displayctrl 1018) ctrlSetTextColor [1,0,0,1];
					
					//FLIR off
					LDL_showFlir = false;
					(_display displayctrl 1017) ctrlSetTextColor [0,0,0,1];
					[LDL_inversion]call LDL_createEffect;
				};
				
				[]call LDL_enableNVG;
			};
			
			if (_dikCode == 63) then
			{
				//F5 pressed
				if (LDL_showBlink) then 
				{
					LDL_showBlink = false;
					(_display displayctrl 1002) ctrlSetText "Show Blink Signal off";
					(_display displayctrl 1019) ctrlSetTextColor [0,0,0,1];
				}
				else
				{
					LDL_showBlink = true;
					(_display displayctrl 1002) ctrlSetText "Show Blink Signal on";
					(_display displayctrl 1019) ctrlSetTextColor [1,0,0,1];
				};
			};
			
			if (_dikCode == 64) then
			{
				//F6 pressed
				if (LDL_showTroops) then 
				{
					LDL_showTroops = false;
					(_display displayctrl 1002) ctrlSetText "Show Troops off";
					(_display displayctrl 1020) ctrlSetTextColor [0,0,0,1];
				}
				else
				{
					LDL_showTroops = true;
					(_display displayctrl 1002) ctrlSetText "Show Troops on";
					(_display displayctrl 1020) ctrlSetTextColor [1,0,0,1];
				};
			};
			
			if (_dikCode == 65) then
			{
				//F7 pressed
				if (LDL_showWaypoints) then 
				{
					LDL_showWaypoints = false;
					(_display displayctrl 1002) ctrlSetText "Show Waypoints off";
					(_display displayctrl 1021) ctrlSetTextColor [0,0,0,1];
				}
				else
				{
					LDL_showWaypoints = true;
					(_display displayctrl 1002) ctrlSetText "Show Waypoints on";
					(_display displayctrl 1021) ctrlSetTextColor [1,0,0,1];
				};
			};
			
			if (_dikCode == 2) then
			{
				//1 pressed
				[0]call LDL_switchWeapon;
			};
			
			if (_dikCode == 3) then
			{
				//2 pressed
				[1]call LDL_switchWeapon;
			};
			
			if (_dikCode == 4) then
			{
				//3 pressed
				[2]call LDL_switchWeapon;
			};
			
			LDL_pressedKey = [_dikCode,_ctrl,_shift,_ctrlKey,_alt];
		};
		
		case "up":
		{	
			LDL_pressedKey = [-1,false,false,false,false];
		};
	};
	 

};

LDL_MouseEvents =
{
	private["_param","_type","_x","_y","_check1","_check2","_type","_button","_shift","_wheel","_zoom","_inversion","_display"];
	
	_param = _this select 1;
	_type = _this select 0;
	_x = 0;
	_y = 0;
	_display = (finddisplay  1000);
	
	switch (_type) do 
	{
		case "MouseMoving": 
		{
			_x = ((_param select 1)-0.5);
			_y = ((_param select 2)-0.5)*-1;	
			LDL_mousePosition = [_x,_y];					
		};
		case "MouseButtonDown": 
		{
			_button = _param select 1;
			_shift = _param select 4;
			LDL_mouseButtons set[_button, true];
			LDL_mouseButtons set[4, _shift];
		};	
		case "MouseButtonUp": 
		{
			_button = _param select 1;
			LDL_mouseButtons set[_button, false];
		};	
		case "MouseZChanged": 
		{
			_wheel = _param select 1;
			if (!(LDL_pressedKey select 0 == 42)) then
			{
				//Zoom
				if(_wheel > 0) then
				{
					[(LDL_zoomLevel + 0.5)]call LDL_setCamFov;
				}
				else
				{
					[(LDL_zoomLevel - 0.5)]call LDL_setCamFov;
				};
			}
			else
			{
				//Flir
				if(LDL_showFlir) then
				{
					LDL_inversion = LDL_inversion - _wheel/50;
					if (LDL_inversion > 1.0) then {LDL_inversion = 1.0};
					if (LDL_inversion < 0.1) then {LDL_inversion = 0.1};
					_inversion = LDL_inversion*10;
					(_display displayctrl 1002) ctrlSetText format ["Contrast: %1",_inversion]; 
					[LDL_inversion]call LDL_createEffect;	
				};
			};
		};	
	};	
};

LDL_setCamFov = 
{
	private["_level","_display"];
	disableSerialization;
	
	_level = _this select 0;
	_display = (finddisplay  1000);
	
	LDL_zoomLevel = (LDL_maxZoomLevel min _level) max 1;
	
	(_display displayctrl 1002) ctrlSetText format ["Zoom: %1x",LDL_zoomLevel]; 
	
	[]spawn
	{
		if(LDL_camFov > (1 - LDL_zoomLevel/10)) then
		{
			while{LDL_camFov > (1 - LDL_zoomLevel/10)} do
			{
				sleep 0.001;
				LDL_camFov = LDL_camFov - 0.005;
			};
		}
		else
		{
			while{LDL_camFov < (1 - LDL_zoomLevel/10)} do
			{
				sleep 0.001;
				LDL_camFov = LDL_camFov + 0.005;
			};	
		};
		
		LDL_camFov = 1 - LDL_zoomLevel/10;
	};
};

LDL_createCam =
{
	private ["_cam"];
	
	_cam = "camera" camcreate [0, 0, 0];
	_cam cameraeffect ["internal", "back"];
	_cam camSetFov LDL_camFov;
	_cam setDir 0;
	
	showCinemaBorder false;
	camUseNVG false;

	_cam camSetTarget LDL_cam_rotating_center;
	_cam camCommit 0;
	
	[0.1]call LDL_createEffect;
	
	[LDL_zoomLevel]call LDL_setCamFov;
	
	if(LDL_useNVG) then
	{
		camUseNVG true;
	};
	
      _cam;
};

LDL_enableNVG = 
{
	switch(LDL_typeNVG) do
	{
		case 0:
		{
			//green
			if(LDL_useNVG) then
			{
				camUseNVG true;
			}
			else
			{
				camUseNVG false;
			};
		};
		case 1:
		{
			//grey
			camUseNVG false;
			if(LDL_useNVG) then
			{
				[]call setCamAperture;	
			}
			else
			{
				setaperture -1;
			};

		};
	};
};

LDL_setCamAperture = 
{
	private["_daytime"];
	
	_daytime = round daytime;
	switch (_daytime) do 
	{
		case 0:{setaperture 0.05;};
		case 1:{setaperture 0.1};
		case 2:{setaperture 0.1;};
		case 3:{setaperture 0.1;};
		case 4:{setaperture 0.1;};
		case 5:{setaperture 0.1;};
		case 6:{setaperture 1.0;};
		case 7:{setaperture 4.0;};
		case 8:{setaperture 12.0;};
		case 9:{setaperture 23.0;};
		case 15:{setaperture 25.0;};
		case 16:{setaperture 14.0;};
		case 17:{setaperture 4.0;};
		case 18:{setaperture 1.0;};
		case 19:{setaperture 0.03;};
		case 20:{setaperture 0.03;};
		case 21:{setaperture 0.03;};
		case 22:{setaperture 0.03;};
		case 23:{setaperture 0.05;};
		case 24:{setaperture 0.05;};
		default {setaperture 35.0;};
	};
};

LDL_createEffect =
{
	private ["_inversion"];
	
	_inversion = _this select 0;
	
	ppEffectDestroy LDL_ppccor;
      ppEffectDestroy LDL_ppcinv;
      ppEffectDestroy LDL_ppfilm;
      ppEffectDestroy LDL_ppdyblur;
      setAperture -1; 
      
      switch(LDL_plane_type) do
      {
		case "AC130":
		{
		 	if(LDL_showFlir) then
     		 	{
	     			#include "ac130_ppEffects.sqf";
				[]call LDL_setCamAperture;
			};
			
		};
		case "UAV":
		{
			if(LDL_showFlir) then
     		 	{
	     			#include "ac130_ppEffects.sqf";
				[]call LDL_setCamAperture;
			}
			else
			{
				#include "UAV\uav_ppEffects.sqf";
			};
		};      
	};
      

};

LDL_changeView = 
{
	private["_display"];
	
	_display = (finddisplay  1000);

	if (LDL_viewMode == 1) then
	{
		//interior
		LDL_viewMode = 0;
		(_display displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
		[LDL_equippedWeapon]call LDL_switchWeapon;
	}
	else
	{
		//exterior
		LDL_viewMode = 1;
		(_display displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/32,SafeZoneY + SafeZoneH/2 - SafeZoneH/32,SafeZoneW/16,SafeZoneH/16];			
		(_display displayctrl 1007) ctrlSetText "ac130\Pictures\VisExt.paa";
		(_display displayctrl 1007) ctrlCommit 0;
	}; 	
};

LDL_getObjectAngles = 
{
	private["_obj1","_obj2","_x1","_x2","_y1","_y2","_angH","_c","_a","_b","_q","_p","_h","_angV"];
	
	_obj1 = _this select 0;
	_obj2 = _this select 1;
	
	_x1 = getPos _obj1 select 0;
	_x2 = getPos _obj2 select 0;
	_y1 = getPos _obj1 select 1;
	_y2 = getPos _obj2 select 1;
	
	_angH = (_x2-_x1) atan2 (_y2-_y1);
	
	_c = _obj1 distance _obj2;
	_a = (getPosASL _obj1 select 2) - (getPosASL _obj2 select 2);
	_b = sqrt(_c^2 - _a^2);
	_q = _a^2/_c;
	_p = _c - _q;
	_h = sqrt(_p*_q);
	_angV = atan(_h/_p);
	if(_a > 0) then
	{
		_angV = 360 - _angV;
	};	
	
	[_angH,_angV];
};

LDL_normalizeAngle = 
{
	private["_angle"];
	
	_angle = _this select 0;
	if (_angle > 360) then {_angle = _angle - 360;};
	if (_angle < 0) then {_angle = 360 + _angle;};
	_angle; 
};

LDL_switchWeapon = 
{
	private["_weapon","_display"];
	
	_weapon = _this select 0;
	_display = (finddisplay  1000);
	
	if(LDL_plane_type == "AC130") then
	{
		if (_weapon < 0) then
		{
			
			if (LDL_equippedWeapon + 1 >= 3) then
			{
				LDL_equippedWeapon = 0;
			}
			else
			{
				LDL_equippedWeapon = LDL_equippedWeapon + 1;
			};
		}
		else
		{
			LDL_equippedWeapon = _weapon;
		};
		
		if (LDL_viewMode == 0) then
		{
			(_display displayctrl 1007) ctrlSetPosition [SafeZoneX + SafeZoneW/2 - SafeZoneW/8,SafeZoneY + SafeZoneH/2 - SafeZoneH/8,SafeZoneW/4,SafeZoneH/4];
			
			switch (LDL_equippedWeapon) do
			{
				case 0:
				{
					(_display displayctrl 1007) ctrlSetText "ac130\Pictures\Vis25mm.paa"; 
					(_display displayctrl 1007) ctrlCommit 0;
				};
				case 1:
				{
					(_display displayctrl 1007) ctrlSetText "ac130\Pictures\Vis40mm.paa"; 
					(_display displayctrl 1007) ctrlCommit 0;
				};
				case 2:
				{
					(_display displayctrl 1007) ctrlSetText "ac130\Pictures\Vis105mm.paa"; 
					(_display displayctrl 1007) ctrlCommit 0;
				};
			};
		};
		
		switch (LDL_equippedWeapon) do
		{
			case 0:
			{
				(_display displayctrl 1001) ctrlSetText "25mm (AP)"; 
				if(LDL_Ammo25 > 0) then
				{
					(_display displayctrl 1001) ctrlSetTextColor [1,1,1,1];
				}
				else
				{
					(_display displayctrl 1001) ctrlSetTextColor [1,0,0,1];
				};
				(_display displayctrl 1001) ctrlCommit 0;
				
				LDL_maxZoomLevel = LDL_zoomMax select 0;
				
				[LDL_zoomLevel]call LDL_setCamFov;
			};
			case 1:
			{
				(_display displayctrl 1001) ctrlSetText "40mm (SABOT)"; 
				if(LDL_Ammo40 > 0) then
				{
					(_display displayctrl 1001) ctrlSetTextColor [1,1,1,1];
				}
				else
				{
					(_display displayctrl 1001) ctrlSetTextColor [1,0,0,1];
				};
				(_display displayctrl 1001) ctrlCommit 0;
				
				LDL_maxZoomLevel = LDL_zoomMax select 1;
				
				[LDL_zoomLevel]call LDL_setCamFov;
			};
			case 2:
			{
				(_display displayctrl 1001) ctrlSetText "105mm (HEAT)"; 
				if(LDL_Ammo105 > 0) then
				{
					(_display displayctrl 1001) ctrlSetTextColor [1,1,1,1];
				}
				else
				{
					(_display displayctrl 1001) ctrlSetTextColor [1,0,0,1];
				};
				(_display displayctrl 1001) ctrlCommit 0;
				
				LDL_maxZoomLevel = LDL_zoomMax select 2;
				
				[LDL_zoomLevel]call LDL_setCamFov;
			};
		};
	
	}
	else
	{
		(_display displayctrl 1007) ctrlSetText "ac130\Pictures\VisTV.paa"; 
		(_display displayctrl 1007) ctrlCommit 0;	
	};
};

LDL_calculateBullet = 
{
	private["_dirh","_dirv","_weapon","_position","_look","_r_sphere","_z","_r","_x","_y","_color","_size","_vel","_weight","_volume","_drag","_shell"];
	
	_dirh = _this select 0;
	_dirv = _this select 1;
	_weapon = _this select 2;
	_position = _this select 3;
	
	_look =  screenToWorld [0.5,0.5];
	
	_spread = (random 100)/500;
	_dirh = _dirh + sin(random 360)*_spread;
	_dirv = _dirv + cos(random 360)*_spread;

	_r_sphere = 100;
	_z = _r_sphere* cos(_dirv - 90);	
	_r = sqrt(_r_sphere^2 - _z^2);
	_x = sin(_dirh)*_r;
	_y = cos(_dirh)*_r;

	switch (_weapon) do
	{
		case 0:
		{
			if (LDL_Ammo25 > 0) then
			{
				LDL_Ammo25 = LDL_Ammo25 - 1;
				LDL_PublicLDLCannon25Sound = LDL_ac130_plane;
				publicVariable "LDL_PublicLDLCannon25Sound";
				LDL_ac130_plane say ["LDL_gun01",1];

				_vel = [_x * 20,_y * 20,_z * 20];
				//_shell = "B_20mm_AP" createVehicle _position;
				_shell = "G_30mm_HE" createVehicle _position;
				_shell setPos _position;

				#include "ac130_createParticleSource.sqf"
				LDL_PublicLDLCannon25FX = [_shell,_vel,_weapon];
				publicVariable "LDL_PublicLDLCannon25FX";
				
				while {alive _shell} do
				{
					 sleep 0.1;
					 _x = sin(random 360)*0.2;
					 _y = sin(random 360)*0.2;
					 _z = sin(random 360)*0.2;
					 _shell setPos (_shell modelToWorld[_x,_y,_z]);
					 _shell setVelocity _vel;
				};
			};
		};
		
		case 1:
		{
			if (LDL_Ammo40 > 0) then
			{
				LDL_Ammo40 = LDL_Ammo40 - 1;
				LDL_PublicLDLCannon40Sound = LDL_ac130_plane;
				publicVariable "LDL_PublicLDLCannon40Sound";
				LDL_ac130_plane say ["LDL_gun02",1];

				_vel = [_x *20,_y * 20,_z * 20];
				_shell = "Sh_120_SABOT" createVehicle _position;
				_shell setPos _position;

				#include "ac130_createParticleSource.sqf"
				LDL_PublicLDLCannon40FX = [_shell,_vel,_weapon];
				publicVariable "LDL_PublicLDLCannon40FX";

				while {alive _shell} do
				{
					 sleep 0.1;
					 _x = sin(random 360)*0.5;
					 _y = sin(random 360)*0.5;
					 _z = sin(random 360)*0.5;
					 _shell setPos (_shell modelToWorld[_x,_y,_z]);
					 _shell setVelocity _vel;
				};
			};
		};
		
		case 2:
		{
			if (LDL_Ammo105 > 0) then
			{
				LDL_Ammo105 = LDL_Ammo105 - 1;
				LDL_PublicLDLCannon105Sound = LDL_ac130_plane;
				publicVariable "LDL_PublicLDLCannon105Sound";
				LDL_ac130_plane say ["LDL_gun03",1];

				_vel = [_x * 20,_y * 20,_z * 20];
				_shell = "Sh_120_HE" createVehicle _position;
				_shell setPos _position;

				#include "ac130_createParticleSource.sqf"
				LDL_PublicLDLCannon105FX = [_shell,_vel,_weapon];
				publicVariable "LDL_PublicLDLCannon105FX";
				
				while {alive _shell} do
				{
					 sleep 0.1;
					 _x = sin(random 360)*0.5;
					 _y = sin(random 360)*0.5;
					 _z = sin(random 360)*0.5;
					 _shell setPos (_shell modelToWorld[_x,_y,_z]);
					 _shell setVelocity _vel;
				};
			};
		};
	};
};

LDL_showHelp = 
{
	private["_display"];
	
	disableSerialization;
	_display = (finddisplay  1000);
	
	titleText [format 
	["
		Move your Mouse to aim\n
		LEFT MOUSE: Fire\n
		RIGHT MOUSE: Set new Position
		MOUSE WHEEL: Zoom\n
		MOUSE WHEEL + SHIFT: Contrast\n
		1 2 3 or ^: Change Weapons\n
		F1: Help
		F2: Enable/disable FLIR\n
		F3: Change view\n
		F4: Enable/disable night vision googles\n
		F5: Enable/disable showing signal for friendly units\n
		F6: Enable/disable showing vehicles on Hud\n
		F7: Enable/disable showing waypoints\n
		ESC: Abort\n
	"], "BLACK OUT",2];
	
	for [{_i = 1;},{_i < 17},{_i = _i + 1;}] do 
	{
		(_display displayctrl (1000 + _i)) ctrlShow false;
	};
	
	for [{_i = 0;},{_i < 12},{_i = _i + 1;}] do 
	{
		(_display displayctrl (2000 + _i)) ctrlShow false;
	};
	
	sleep 4;
	titleFadeOut 1;
	
	for [{_i = 1;},{_i < 17},{_i = _i + 1;}] do 
	{
		(_display displayctrl (1000 + _i)) ctrlShow true;
	};
	
	for [{_i = 0;},{_i < 12},{_i = _i + 1;}] do 
	{
		(_display displayctrl (2000 + _i)) ctrlShow true;
	};
};

LDL_setVariables = 
{
	private["_var","_color","_size","_glowSize","_vel","_weight","_volume","_drag","_shell","_type","_soundSource","_sound"];

	setMousePosition [0.5,0.5];
	LDL_mousePosition = [0,0];
	LDL_mouseButtons = [false,false,false,false,false];
	LDL_shootingGun25 = false;
	LDL_shootingGun40 = false;
	LDL_shootingGun105 = false;
	LDL_pressedKey = [-1,false,false,false,false];
	LDL_equippedWeapon = 0;
	LDL_guns_enabled = false;
	LDL_camFov = 1;
	LDL_viewMode = 0;
	LDL_cam_rotating_angle = 180;	
	LDL_cam_rotating_dirh = 0; 
	LDL_cam_rotating_deg = 0.1;	
	LDL_cam_dirh = 0;
	LDL_cam_dirv = 300;
	LDL_guns_dirh = 0;
	LDL_guns_dirv = 300;
	LDL_flyMode = 0; //0: no AI, 1: rotating, 2: waiting to float, 3: float
	LDL_zoomLevel = 1;
	LDL_zoomMax = [_this select 15,_this select 16,_this select 17];
	LDL_maxZoomLevel = _this select 15;
	LDL_cam_rotating_radius = _this select 0;	
	LDL_cam_rotating_height = _this select 1;	
	LDL_heightASL = _this select 2;
	LDL_startTime = time;
	LDL_endTime = _this select 18;
	LDL_ac130_abort = false;
	LDL_scriptTerminated = 0;

	_var = (LDL_ac130_plane getVariable "LDL_Ammo25");
	if (isNil "_var") then
	{
		LDL_Ammo25 = _this select 3;
	}
	else
	{
		LDL_Ammo25 = _var;
	};
	
	_var = (LDL_ac130_plane getVariable "LDL_Ammo40");

	if (isNil "_var") then
	{
		LDL_Ammo40 = _this select 4;
	}
	else
	{
		LDL_Ammo40 = _var;
	};
	
	_var = (LDL_ac130_plane getVariable "LDL_Ammo105");

	if (isNil "_var") then
	{
		LDL_Ammo105 = _this select 5;
	}
	else
	{
		LDL_Ammo105 = _var;
	};
	LDL_showBlink = _this select 6;
	LDL_showTroops = _this select 7;
	LDL_showFlir = _this select 8;
	LDL_inversion = _this select 9;
	LDL_view360 = _this select 10;
	LDL_useNVG  = _this select 11;
	LDL_typeNVG  = _this select 12;
	LDL_showWaypoints = _this select 13;
	LDL_showParticles = _this select 14;
	//Keyboard listener
	if(LDL_plane_type != "AC130_AI") then
	{
		sleep 1;
		LDL_KeyDownDEH = (findDisplay 46) displayAddEventHandler ["keyDown","[_this,'down'] call LDL_KeyEvents"];
		LDL_KeyUpDEH = (findDisplay 46) displayAddEventHandler ["keyUp","[_this,'up'] call LDL_KeyEvents"];
		
		LDL_ppccor = ppEffectCreate ["ColorCorrections", 1];
	      LDL_ppcinv = ppEffectCreate ["colorInversion", 2];
	      LDL_ppfilm = ppEffectCreate ["filmGrain", 3];
	      LDL_ppdyblur = ppEffectCreate ["dynamicBlur", 0];
      };
};

